use super::{Magic, UdpData};

use std::sync::mpsc::{Receiver, Sender};

use std::net::UdpSocket;

use std::convert::TryInto;

use std::sync::Arc;

pub fn u32_to_vec_u8(u: &u32) -> [u8; 4] {
    [
        (((u >> 24) & 255) as u8).try_into().unwrap(),
        (((u >> 16) & 255) as u8).try_into().unwrap(),
        (((u >> 8) & 255) as u8).try_into().unwrap(),
        ((u & 255) as u8).try_into().unwrap(),
    ]
}

pub fn udp_recv_thread(socket: Arc<UdpSocket>, recv_send: Vec<Sender<UdpData>>) {}

pub fn udp_send_thread(socket: Arc<UdpSocket>, recv_send: Receiver<UdpData>) {
    loop {
        match recv_send.recv() {
            Ok(res) => {
                let mut msg: Vec<u8>;

                match &res.magic {
                    Magic::Hinit => {
                        msg = vec![res.magic as u8];
                        msg.extend_from_slice(&u32_to_vec_u8(&res.id_src));
                    }
                    Magic::Hack => {
                        msg = vec![res.magic as u8];
                        msg.extend_from_slice(&u32_to_vec_u8(&res.id_dst.unwrap()));
                        msg.extend_from_slice(&u32_to_vec_u8(&res.id_src));
                    }
                    Magic::Hdata => {
                        msg = vec![res.magic as u8];
                        msg.extend_from_slice(&u32_to_vec_u8(&res.id_dst.unwrap()));
                    }
                };

                msg.extend(&res.payload);

                match socket.send_to(&msg, res.addr) {
                    _ => (),
                }
            }
            Err(_) => (),
        };
    }
}
